package org.aiwolf.MayQueen;

import java.util.ArrayList;
import java.util.Deque;
import java.util.LinkedList;
import java.util.List;

import org.aiwolf.client.lib.ComingoutContentBuilder;
import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.DivinationContentBuilder;
import org.aiwolf.client.lib.DivinedResultContentBuilder;
import org.aiwolf.client.lib.EstimateContentBuilder;
import org.aiwolf.client.lib.RequestContentBuilder;
import org.aiwolf.client.lib.VoteContentBuilder;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.data.Talk;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

public class MyPossessed extends MyBasePlayer {

	boolean isCo;//カミングアウトしたかどうか

	boolean ppco;

	int coseer;

	boolean five;

	List<Judge> fakeDivinationList = new ArrayList<>();//偽占いリスト

	Deque<Judge> fakeDivinationQueue = new LinkedList<>();//偽占いキュー

	List<Agent> divinedAgents = new ArrayList<>();//偽占いしたエージェントリスト

	List<Agent> subvote = new ArrayList<>();

	int talkturn = 0;/** 延々と投票先を発言する*/

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);// 基底クラスの処理を実⾏

		/** 各変数とリストを初期化*/
		isCo = false;
		ppco=false;
		fakeDivinationList.clear();
		fakeDivinationQueue.clear();
		divinedAgents.clear();
		subvote.clear();
		coseer=0;
	}

	@Override
	public void dayStart() {
		super.dayStart();// 基底クラスの処理を実⾏
		if (day == 0) {
			if(aliveOthers.size()==4) {
				five=true;
			}else {
				five=false;
			}
		}

		// 偽の判定
		if (day > 0) {
			Judge judge = getFakeDivination();
			if (judge != null) {
				fakeDivinationList.add(judge);
				fakeDivinationQueue.offer(judge);
				divinedAgents.add(judge.getTarget());
			}
		}
	}


	@Override
	public Agent chooseVote() {
		werewolves.clear();//人狼候補リストを空にする
		List<Agent> candidates = new ArrayList<>();//占い候補
		if (day == 1) {
			for (Agent a : aliveOthers) {
				//占い師の数を数える
				if (comingoutMap.get(a) == Role.SEER) {
					coseer++;
				}
			}
		}
		coseer++;
		if (day == 1&&coseer==2&&five) {
			for (Agent a : aliveOthers) {
				if (comingoutMap.get(a) == Role.SEER) {
					subvote.add(a);
				}
			}
		}

		if(ppco) {
				candidates=subvote;
			if(candidates.isEmpty()) {
			for (Agent a : aliveOthers) {
				//人狼COしてなければ投票リストに入れる
				if (comingoutMap.get(a) != Role.WEREWOLF) {
					candidates.add(a);
				}
			}
			}
			for (Judge j : divinationList) {
				// 自分や殺されたエージェントを人狼と判定している占い師は人狼候補としてリストに格納
				if (j.getResult() == Species.WEREWOLF && (j.getTarget() == me || killedAgents.contains(j.getTarget()))) {
					if (!werewolves.contains(j.getAgent())) {
						werewolves.add(j.getAgent());
					}
				}
			}
			if (candidates.isEmpty()) {
				for (Agent a : aliveOthers) {
					if (!werewolves.contains(a)) {
						candidates.add(a);
					}
				}
			}
			if (candidates.isEmpty()) {
				for (Agent a : aliveOthers) {
					candidates.add(a);
				}
			}

		}else {
		for (Judge j : divinationList) {
			// 自分や殺されたエージェントを人狼と判定している占い師は人狼候補としてリストに格納
			if (j.getResult() == Species.WEREWOLF && (j.getTarget() == me || killedAgents.contains(j.getTarget()))) {
				if (!werewolves.contains(j.getAgent())) {
					werewolves.add(j.getAgent());
				}
			}
		}

		for (Agent a : aliveOthers) {
			// 対抗カミングアウトのエージェントは投票先候補
			if (!werewolves.contains(a) && comingoutMap.get(a) == Role.SEER) {
				candidates.add(a);
			}
		}

		List<Agent> fakeHumans = new ArrayList<>();//偽占いで人間と判定したリスト
		for (Judge j : fakeDivinationList) {
			if (j.getResult() == Species.HUMAN) {
				//偽占いで人間と判定したリストに格納
				if (!fakeHumans.contains(j.getTarget())) {
					fakeHumans.add(j.getTarget());
				}
			} else {
				// 偽占いで人狼と判定したエージェントは投票先候補
				if (!candidates.contains(j.getTarget())) {
					candidates.add(j.getTarget());
				}
			}
		}

		if (candidates.isEmpty()) {
			for (Agent a : aliveOthers) {
				// 候補がいなければ人間と判定していない村人陣営から
				if (!werewolves.contains(a) && !fakeHumans.contains(a)) {
					candidates.add(a);
				}
			}
		}

		if (candidates.isEmpty()) {
			for (Agent a : aliveOthers) {
				// それでも候補がいなければ村人陣営から
				if (!werewolves.contains(a)) {
					candidates.add(a);
				}
			}
		}
		}
		voteCandidate = randomSelect(candidates);
		if (canTalk) {
			talkQueue.offer(new Content(new EstimateContentBuilder(voteCandidate, Role.WEREWOLF)));//推測発言
			talkQueue.offer(new Content(
					new RequestContentBuilder(null, new Content(new DivinationContentBuilder(voteCandidate)))));//占い要請
		}
		return voteCandidate;
	}


	@Override
	public String chooseTalk() {
		// 即占い師カミングアウト
		if (!isCo) {
			isCo = true;
			return (new Content(new ComingoutContentBuilder(me, Role.SEER))).getText();
		}

		if (isCo) {
			//これまでの偽占い結果をすべて公開
			while (!fakeDivinationQueue.isEmpty()) {
				Judge divination = fakeDivinationQueue.poll();
				return (new Content(new DivinedResultContentBuilder(divination.getTarget(), divination.getResult()))).getText();
			}
		}
		if(aliveOthers.size()<=3&&!ppco) {
			isCo = true;
			ppco = true;
			return (new Content(new ComingoutContentBuilder(me, Role.POSSESSED))).getText();
		}


		talkturn++;/** 延々と投票先を発言する*/

		if (talkturn > 1 && talkQueue.isEmpty()) { // 発⾔キューが空なら

			return (new Content(new VoteContentBuilder(vote()))).getText();
		}

		return Talk.SKIP;
//		return super.talk();
	}


	/** 偽占い結果を取得*/
	private Judge getFakeDivination() {
		Agent target = null;//偽占い対象
		List<Agent> candidates = new ArrayList<>();//偽占い候補リスト
		Species result = Species.HUMAN;//偽占い結果

		for (Agent a : aliveOthers) {
			//偽占い済みではなく，占い師をカミングアウトしていなければ偽占い候補に入れる
			if (!divinedAgents.contains(a) && comingoutMap.get(a) != Role.SEER) {
				candidates.add(a);
			}
		}

		if (!candidates.isEmpty()) {
			//偽占い候補リストが空でなければその中からランダム
			target = randomSelect(candidates);
		} else {
			//偽占い候補リストが空なら生きているエージェントからランダムに選択
			target = randomSelect(aliveOthers);
		}

		// 偽占いで人狼と言っていなければ，20%の確率で人狼と判定
		int nFakeWolves = 0;//偽占いでいった人狼の数
		for (Judge j : fakeDivinationList) {
			if (j.getResult() == Species.WEREWOLF) {
				nFakeWolves++;
			}
		}
		if (nFakeWolves < numWolves() ) {
			result = Species.WEREWOLF;
		}

		return new Judge(day, me, target, result);
	}

}
